unit Unit1;

interface

uses
  Windows, Classes, Menus, Forms, Controls, Richer, StdCtrls, ComCtrls,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    DoStuff1: TMenuItem;
    Find1: TMenuItem;
    Underline1: TMenuItem;
    H1: TMenuItem;
    z1: TMenuItem;
    SpaceOut1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Underline1Click(Sender: TObject);
    procedure HighlightClick(Sender: TObject);
    procedure ZoomClick(Sender: TObject);
    procedure SpaceOut1Click(Sender: TObject);

  private
      RE1:TRichedit;
      RE2:TRicherEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses Richedit;

procedure TForm1.FormResize(Sender: TObject);
var halfwit:integer;
    i:integer;
begin
 halfwit:=ClientWidth div 2;

{ Panel1.SetBounds(0,0,halfwit,Clientheight);
 Panel2.SetBounds(halfwit+1,0,halfwit,Clientheight);
}

{I did it this way so that it compiles even when the panels
are not there as was the case at the start of the demo!}
 for i:=0 to ComponentCount-1 do
   if Components[i].Name='Panel1' then
     TControl(Components[i]).SetBounds(0,0,halfwit,Clientheight)
   else if Components[i].Name='Panel2' then
     TControl(Components[i]).SetBounds(halfwit+1,0,halfwit,Clientheight);
end;


procedure TForm1.FormCreate(Sender: TObject);
   procedure Props(re:Trichedit);
   begin
      re.Align:=alClient;
      re.WordWrap:=True;
      re.ScrollBars:=ssVertical;
      re.HandleNeeded;
      {Don't forget the magic words, or the tabstops will all be ordinary ones}
      re.Perform(EM_SETTYPOGRAPHYOPTIONS,TO_ADVANCEDTYPOGRAPHY,TO_ADVANCEDTYPOGRAPHY);

      re.HideSelection:=False;
      re.Lines.LoadFromFile('tabs.rtf');
   end;

begin  {FormCreate}
  RE1:=TRichedit.Create(self);
  Re1.Parent:=Panel1;

  Re2:=TricherEdit.Create(self);
  Re2.Parent:=Panel2;

  Props(Re1);
  Props(Re2);
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
 Re1.SelStart:=Re1.FindText('i',re1.SelStart+1,$FFFFF,[]);
 Re2.SelStart:=Re2.FindText('i',re2.SelStart+1,$FFFFF,[]);

 Re1.SelLength:=1;
 Re2.SelLength:=1;

 {for some years now, a newsgroup FAQ has been how to bring the selection
  into view after programmattically setting SelStart... It happened automatically
  with the early DLLs, and it seems to me that it is working automatically with
  my XP(sp2) DLLs too.
  However, to cater for W2K DLLs it does no harm to include the following call}
 Re1.Perform(EM_SCROLLCARET,0,0);
 Re2.Perform(EM_SCROLLCARET,0,0);
end;

procedure TForm1.Underline1Click(Sender: TObject);
var cf:TCharFormat2;
    colour:integer;
    linestyle:integer;
begin
   colour:=5; {Red}
        {options for colour
         0: black              1: blue
         2: cyan               3: green
         4: magenta            5: red
         6: yellow             7: white }

   linestyle:=8; {wavy}
   {Alternatives : constants defined in richedit unit
  CFU_UNDERLINEDOTTED         = $4;
  CFU_UNDERLINEDOUBLE         = $3;  (But doesn't seem to act as expected)
  CFU_UNDERLINEWORD           = $2;  ( ditto )
  CFU_UNDERLINE               = $1;
  CFU_UNDERLINENONE           = 0;
  also (undocumented - well, they're probably listed *somewhere* on MSDN):
  5 : long dashes
  6 ,7 : 'morse code'
  8 : wavy
  9 - 15 : thick as mud          }

   cf.cbSize:=sizeof(cf);
   cf.dwMask:=cfm_underlinetype;
   cf.dwEffects:=cfe_underline;
   cf.bUnderlineType:=linestyle + (colour*16);

 re1.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
 re2.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
end;

procedure TForm1.HighlightClick(Sender: TObject);
var cf:TCharFormat2;
begin
   cf.cbSize:=sizeof(cf);
   cf.dwMask:=cfm_backcolor;

   cf.crBackColor:=rgb(210,210,230);  {pale blue}

   re1.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
   re2.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
end;

procedure TForm1.ZoomClick(Sender: TObject);
{$J+}
const f:integer=100;
begin
  f:=f*2;
  re1.Perform(EM_SETZOOM,f,100);
  re2.Perform(EM_SETZOOM,f,100);
end;

procedure TForm1.SpaceOut1Click(Sender: TObject);
{this one added in response to Susie's question}
var cf:TCharFormat2;
begin
   cf.cbSize:=sizeof(cf);
   cf.dwMask:=cfm_spacing;
   cf.sSpacing:=100;

   re1.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
   re2.perform(EM_SETCHARFORMAT,SCF_SELECTION,Lparam(@cf));
end;

END.

